﻿init python:
    def random():
        return renpy.random.random()
    def randint(low, high):
        return renpy.random.randint(low, high)
    def choose(l):
        return renpy.random.choice(l)
    
    class restaurant_table:
        def __init__ (self, x, y):
            self.x = x
            self.y = y
            self.left = None
            self.right = None

    class restaurant_waiter:
        def __init__(self):
            self.name = "waiter"
            self.speed = 2
            self.cash = 0
            self.x = 0
            self.y = 0
            self.direction = "up"
            self.stat = "normal"
            self.game = None
        def update(self):
            if not self.stat in ["dead", "paused"]:
                if self.direction == "up" and self.y > self.game.depth:
                    self.y -= self.speed
                elif self.direction == "down"  and self.y < 0:
                    self.y += self.speed
                elif self.direction == "left" and self.x > -self.game.width/2:
                    self.x -= self.speed
                elif self.direction == "right" and self.x < self.game.width/2:
                    self.x += self.speed
        def change_direction(self, direction):
            self.direction = direction
        def change_speed(self, speed):
            self.speed += speed
            if self.speed < 1:
                self.speed = 1


    class restaurant_class:
        def __init__ (self, bg, depth, width, tables, food, clients):
            self.waiter = None
            self.layout = []
            self.bg = bg
            self.depth = -depth
            self.width = width
            self.tables = tables
            self.food = food
            self.clients = clients
        def start(self, waiter):
            waiter.game = self
            self.waiter = waiter
        def update(self):
            pass
            self.waiter.update()
        def client_sit(self):
            chance = randint(1,10)
            if chance > 7:
                table = choose(self.tables)
                side = choose([0,1])
                client = choose(self.clients)
                food = choose(self.food)
                patience = randint(20, 60)
                if side:
                    if not table.left:
                        table.left = [client, food, patience]
                else:
                    if not table.right:
                        table.right = [client, food, patience]

            for i in self.tables:
                if i.left:
                    i.left[2] -= 1
                    if i.left[2] < 1:
                        i.left = None
                if i.right:
                    i.right[2] -= 1
                    if i.right[2] < 1:
                        i.right = None
transform zoom(z):
    zoom z

screen waiter_screen(g, w):
    modal True
    on "show" action Function(g.start, w)
    frame align .5,1.0 background "#2f1e45" padding 0,0 xysize 960,540:
        add g.bg align .5,1.0
        at zoom(2)
        if g.waiter:
            key "w" action Function(g.waiter.change_direction, "up")
            key "s" action Function(g.waiter.change_direction, "down")
            key "a" action Function(g.waiter.change_direction, "left")
            key "d" action Function(g.waiter.change_direction, "right")
            timer .016 repeat True action Function(g.update)
            fixed fit_first True align .5,1.0  offset g.waiter.x, g.waiter.y:
                add g.waiter.name + " " + g.waiter.direction yoffset -16
        for i in g.tables:
            fixed fit_first True align .5,1.0 offset i.x,i.y:
                add "resturant_table"
                if i.left:
                    fixed fit_first True:
                        add i.left[0] + " right"
                        text str(i.left[2]) size 12 yoffset -26 align .5,.5
                if i.right:
                    fixed fit_first True xalign 1.0:
                        add i.right[0] + " left"
                        text str(i.right[2])  size 12 yoffset -26 align .5,.5


    if g.waiter:
        text "{}/{}".format(g.waiter.x, g.waiter.y)

    timer 1 repeat True action Function(g.client_sit)



# ------------------------------- Create some animation
image waiter down:
    Crop((0, 0, 32, 32), "waiter")
    pause .1
    Crop((32, 0, 32, 32), "waiter")
    pause .1
    Crop((64, 0, 32, 32), "waiter")
    pause .1
    Crop((32, 0, 32, 32), "waiter")
    pause .1
    repeat

image waiter up:
    Crop((0, 96, 32, 32), "waiter")
    pause .1
    Crop((32, 96, 32, 32), "waiter")
    pause .1
    Crop((64, 96, 32, 32), "waiter")
    pause .1
    Crop((32, 96, 32, 32), "waiter")
    pause .1
    repeat

image waiter left:
    Crop((0, 32, 32, 32), "waiter")
    pause .1
    Crop((32, 32, 32, 32), "waiter")
    pause .1
    Crop((64, 32, 32, 32), "waiter")
    pause .1
    Crop((32, 32, 32, 32), "waiter")
    pause .1
    repeat

image waiter right:
    Crop((0, 64, 32, 32), "waiter")
    pause .1
    Crop((32, 64, 32, 32), "waiter")
    pause .1
    Crop((64, 64, 32, 32), "waiter")
    pause .1
    Crop((32, 64, 32, 32), "waiter")
    pause .1
    repeat


image client_1 left:
    Crop((0, 32, 32, 32), "client_1")
    pause .1
    Crop((32, 32, 32, 32), "client_1")
    pause .1
    Crop((64, 32, 32, 32), "client_1")
    pause .1
    Crop((32, 32, 32, 32), "client_1")
    pause .1
    repeat
image client_1 right:
    Crop((0, 64, 32, 32), "client_1")
    pause .1
    Crop((32, 64, 32, 32), "client_1")
    pause .1
    Crop((64, 64, 32, 32), "client_1")
    pause .1
    Crop((32, 64, 32, 32), "client_1")
    pause .1
    repeat

image client_2 left:
    Crop((0, 32, 32, 32), "client_2")
    pause .1
    Crop((32, 32, 32, 32), "client_2")
    pause .1
    Crop((64, 32, 32, 32), "client_2")
    pause .1
    Crop((32, 32, 32, 32), "client_2")
    pause .1
    repeat
image client_2 right:
    Crop((0, 64, 32, 32), "client_2")
    pause .1
    Crop((32, 64, 32, 32), "client_2")
    pause .1
    Crop((64, 64, 32, 32), "client_2")
    pause .1
    Crop((32, 64, 32, 32), "client_2")
    pause .1
    repeat

image client_3 left:
    Crop((0, 32, 32, 32), "client_3")
    pause .1
    Crop((32, 32, 32, 32), "client_3")
    pause .1
    Crop((64, 32, 32, 32), "client_3")
    pause .1
    Crop((32, 32, 32, 32), "client_3")
    pause .1
    repeat
image client_3 right:
    Crop((0, 64, 32, 32), "client_3")
    pause .1
    Crop((32, 64, 32, 32), "client_3")
    pause .1
    Crop((64, 64, 32, 32), "client_3")
    pause .1
    Crop((32, 64, 32, 32), "client_3")
    pause .1
    repeat

image client_4 left:
    Crop((0, 32, 32, 32), "client_4")
    pause .1
    Crop((32, 32, 32, 32), "client_4")
    pause .1
    Crop((64, 32, 32, 32), "client_4")
    pause .1
    Crop((32, 32, 32, 32), "client_4")
    pause .1
    repeat
image client_4 right:
    Crop((0, 64, 32, 32), "client_4")
    pause .1
    Crop((32, 64, 32, 32), "client_4")
    pause .1
    Crop((64, 64, 32, 32), "client_4")
    pause .1
    Crop((32, 64, 32, 32), "client_4")
    pause .1
    repeat

image client_5 left:
    Crop((0, 32, 32, 32), "client_5")
    pause .1
    Crop((32, 32, 32, 32), "client_5")
    pause .1
    Crop((64, 32, 32, 32), "client_5")
    pause .1
    Crop((32, 32, 32, 32), "client_5")
    pause .1
    repeat
image client_5 right:
    Crop((0, 64, 32, 32), "client_5")
    pause .1
    Crop((32, 64, 32, 32), "client_5")
    pause .1
    Crop((64, 64, 32, 32), "client_5")
    pause .1
    Crop((32, 64, 32, 32), "client_5")
    pause .1
    repeat

image client_6 left:
    Crop((0, 32, 32, 32), "client_6")
    pause .1
    Crop((32, 32, 32, 32), "client_6")
    pause .1
    Crop((64, 32, 32, 32), "client_6")
    pause .1
    Crop((32, 32, 32, 32), "client_6")
    pause .1
    repeat
image client_6 right:
    Crop((0, 64, 32, 32), "client_6")
    pause .1
    Crop((32, 64, 32, 32), "client_6")
    pause .1
    Crop((64, 64, 32, 32), "client_6")
    pause .1
    Crop((32, 64, 32, 32), "client_6")
    pause .1
    repeat

image client_7 left:
    Crop((0, 32, 32, 32), "client_7")
    pause .1
    Crop((32, 32, 32, 32), "client_7")
    pause .1
    Crop((64, 32, 32, 32), "client_7")
    pause .1
    Crop((32, 32, 32, 32), "client_7")
    pause .1
    repeat
image client_7 right:
    Crop((0, 64, 32, 32), "client_7")
    pause .1
    Crop((32, 64, 32, 32), "client_7")
    pause .1
    Crop((64, 64, 32, 32), "client_7")
    pause .1
    Crop((32, 64, 32, 32), "client_7")
    pause .1
    repeat


default waiter = restaurant_waiter()
default restaurant_1 = restaurant_class(
    "resturant", 224, 352,
    [
        restaurant_table(-96,-96),
        restaurant_table(-96,-192),
        restaurant_table(64,-64),
        restaurant_table(64,-160),
    ],
    [
        "Burger",
    ],
    [
        "client_1",
        "client_2",
        "client_3",
        "client_4",
        "client_5",
        "client_6",
        "client_7",
    ]
    )
label waiter_game_example:
    call screen waiter_screen(restaurant_1, waiter)

